Package org.apache.sysds.parser

# Class BinaryExpression

java.lang.Object
org.apache.sysds.parser.Expression
org.apache.sysds.parser.BinaryExpression

All Implemented Interfaces:
  `ParseInfo`

public class BinaryExpression extends Expression

## Nested Class Summary

## Nested classes/interfaces inherited from class org.apache.sysds.parser.Expression

`Expression.BinaryOp, Expression.BooleanOp, Expression.DataOp, Expression.FunctCallOp, Expression.RelationalOp`

## Constructor Summary

Constructors
Constructor
Description
`BinaryExpression(Expression.BinaryOp bop)`
`BinaryExpression(Expression.BinaryOp bop, ParseInfo parseInfo)`

## Method Summary

Modifier and Type
Method
Description
`Expression`
`getLeft()`
`Expression.BinaryOp`
`getOpCode()`
`Expression`
`getRight()`
`static boolean`
`isSameDimensionBinaryOp(Expression.BinaryOp op)`
`Expression`
`rewriteExpression(String prefix)`
`void`
`setLeft(Expression l)`
`void`
`setRight(Expression r)`
`String`
`toString()`
`void`
`validateExpression(HashMap<String,DataIdentifier> ids, HashMap<String,ConstIdentifier> constVars, boolean conditional)`
Validate parse tree : Process Binary Expression in an assignment statement
`VariableSet`
`variablesRead()`
`VariableSet`
`variablesUpdated()`

### Methods inherited from class org.apache.sysds.parser.Expression

`computeDataType, computeDataType, computeValueType, computeValueType, computeValueType, convertFormatType, equals, getBeginColumn, getBeginLine, getBinaryMatrixCharacteristics, getBinaryOp, getBooleanOp, getEndColumn, getEndLine, getFilename, getOutput, getOutputs, getParseExceptionList, getRelationalOp, getTempName, getText, hashCode, printErrorLocation, printInfoLocation, printWarningLocation, raiseValidateError, raiseValidateError, raiseValidateError, setBeginColumn, setBeginLine, setCtxValues, setCtxValuesAndFilename, setEndColumn, setEndLine, setFilename, setOutput, setParseExceptionList, setParseInfo, setText, validateExpression`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### BinaryExpression

public BinaryExpression(Expression.BinaryOp bop)

### BinaryExpression

public BinaryExpression(Expression.BinaryOp bop, ParseInfo parseInfo)

## Method Details

### rewriteExpression

public Expression rewriteExpression(String prefix)

Specified by:
  `rewriteExpression` in class `Expression`

### getOpCode

public Expression.BinaryOp getOpCode()

### setLeft

public void setLeft(Expression l)

### setRight

public void setRight(Expression r)

### getLeft

public Expression getLeft()

### getRight

public Expression getRight()

### validateExpression

public void validateExpression(HashMap<String,DataIdentifier> ids, HashMap<String,ConstIdentifier> constVars, boolean conditional)
Validate parse tree : Process Binary Expression in an assignment statement

Overrides:
  `validateExpression` in class `Expression`

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### variablesRead

public VariableSet variablesRead()

Specified by:
  `variablesRead` in class `Expression`

### variablesUpdated

public VariableSet variablesUpdated()

Specified by:
  `variablesUpdated` in class `Expression`

### isSameDimensionBinaryOp

public static boolean isSameDimensionBinaryOp(Expression.BinaryOp op)